<?php

namespace WCAldi\Entities;

class PromosTaxonomy {

    public function init() {

        add_action( 'init', [ $this, 'registerPromosTaxonomy' ] );
        $this->addMetaValues();

    }

    /**
     * Defining the taxonomy for wordpress
     */
    public function registerPromosTaxonomy()  {

        $labels = array(
            'name'                       => 'Especiales semana',
            'singular_name'              => 'Especial semana',
            'menu_name'                  => 'Promociones',
            'all_items'                  => 'Todas las promociones',
        );

        $args = array(
            'labels'                     => $labels,
            'hierarchical'               => true,
            'public'                     => true,
            'show_ui'                    => true,
            'show_admin_column'          => true,
            'show_in_nav_menus'          => true,
            'show_tagcloud'              => true,
            'rewrite'                    => [
                'slug'                      => 'especiales-semana'
            ]
        );

        register_taxonomy( WC_ALDI_TAX_PROMOS, 'product', $args );
        register_taxonomy_for_object_type( WC_ALDI_TAX_PROMOS, 'product' );
    }

    /**
     * Setting meta fields for the taxonomy, using plugin "Advanced Custom Fields"
     */
    public function addMetaValues() {

        if( function_exists('acf_add_local_field_group') ):

            acf_add_local_field_group(array (
                'key' => 'group_59771f4735f95',
                'title' => 'Campos de taxonomía de promociones',
                'fields' => array (
	                array (
		                'message' => '',
		                'ui' => 1,
		                'ui_on_text' => '',
		                'ui_off_text' => '',
		                'key' => 'field_5977201fttc87',
		                'label' => 'Título alternativo',
		                'name' => 'promo_title',
		                'type' => 'text',
		                'required' => 0,
		                'conditional_logic' => 0,
		                'wrapper' => array (
			                'width' => '',
			                'class' => '',
			                'id' => '',
		                ),
	                ),
	                array (
		                'key' => 'field_598ad6f123456',
		                'label' => 'Icono',
		                'name' => 'promo_icon',
		                'type' => 'image',
		                'instructions' => '',
		                'required' => 0,
		                'conditional_logic' => 0,
		                'wrapper' => array (
			                'width' => '',
			                'class' => '',
			                'id' => '',
		                ),
		                'return_format' => 'array',
		                'preview_size' => 'thumbnail',
		                'library' => 'all',
		                'min_width' => '',
		                'min_height' => '',
		                'min_size' => '',
		                'max_width' => '',
		                'max_height' => '',
		                'max_size' => 8,
		                'mime_types' => '',
                    ),
                    array (
		                'key' => 'field_598ad6f22urrg',
		                'label' => 'Imagen en cabecera',
		                'name' => 'promo_header_img',
		                'type' => 'image',
		                'instructions' => '',
		                'required' => 0,
		                'conditional_logic' => 0,
		                'wrapper' => array (
			                'width' => '',
			                'class' => '',
			                'id' => '',
		                ),
		                'return_format' => 'array',
		                'preview_size' => 'thumbnail',
		                'library' => 'all',
		                'min_width' => '',
		                'min_height' => '',
		                'min_size' => '',
		                'max_width' => '',
		                'max_height' => '',
		                'max_size' => 8,
		                'mime_types' => '',
                    ),
                    array (
		                'key' => 'field_598ad6f276tbn',
		                'label' => 'Imagen de precio',
		                'name' => 'promo_price_img',
		                'type' => 'image',
		                'instructions' => '',
		                'required' => 0,
		                'conditional_logic' => 0,
		                'wrapper' => array (
			                'width' => '',
			                'class' => '',
			                'id' => '',
		                ),
		                'return_format' => 'array',
		                'preview_size' => 'thumbnail',
		                'library' => 'all',
		                'min_width' => '',
		                'min_height' => '',
		                'min_size' => '',
		                'max_width' => '',
		                'max_height' => '',
		                'max_size' => 8,
		                'mime_types' => '',
                    ),
                    array (
		                'key' => 'field_59844ff276tbn',
		                'label' => 'Topo',
		                'name' => 'promo_topo',
		                'type' => 'image',
		                'instructions' => '',
		                'required' => 0,
		                'conditional_logic' => 0,
		                'wrapper' => array (
			                'width' => '',
			                'class' => '',
			                'id' => '',
		                ),
		                'return_format' => 'array',
		                'preview_size' => 'thumbnail',
		                'library' => 'all',
		                'min_width' => '',
		                'min_height' => '',
		                'min_size' => '',
		                'max_width' => '',
		                'max_height' => '',
		                'max_size' => 8,
		                'mime_types' => '',
                    ),
                    array (
                        'default_value' => 1,
                        'message' => '',
                        'ui' => 1,
                        'ui_on_text' => '',
                        'ui_off_text' => '',
                        'key' => 'field_5966pp1930818',
                        'label' => 'Color',
                        'name' => 'promo_color',
                        'type' => 'color_picker',
                        'instructions' => '',
                        'required' => 0,
                        'conditional_logic' => 0,
                        'wrapper' => array (
                            'width' => '',
                            'class' => '',
                            'id' => '',
                        ),
                    ),
                    array (
                        'default_value' => 1,
                        'message' => '',
                        'ui' => 1,
                        'ui_on_text' => '',
                        'ui_off_text' => '',
                        'key' => 'field_598jjq1930818',
                        'label' => 'Color de texto',
                        'name' => 'promo_color_text',
                        'type' => 'color_picker',
                        'instructions' => '',
                        'required' => 0,
                        'conditional_logic' => 0,
                        'wrapper' => array (
                            'width' => '',
                            'class' => '',
                            'id' => '',
                        ),
                    ),
                    array (
                        'default_value' => 0,
                        'message' => '',
                        'ui' => 1,
                        'ui_on_text' => '',
                        'ui_off_text' => '',
                        'key' => 'field_59771fad30817',
                        'label' => 'Excluir de listado general',
                        'name' => 'promo_exclude',
                        'type' => 'true_false',
                        'instructions' => 'Excluye el producto del listado general si está activo.',
                        'required' => 0,
                        'conditional_logic' => 0,
                        'wrapper' => array (
                            'width' => '',
                            'class' => '',
                            'id' => '',
                        ),
                    ),
                    array (
                        'default_value' => 1,
                        'message' => '',
                        'ui' => 1,
                        'ui_on_text' => '',
                        'ui_off_text' => '',
                        'key' => 'field_5977201930818',
                        'label' => 'Sustituir precios',
                        'name' => 'promo_change_price',
                        'type' => 'true_false',
                        'instructions' => 'Si está activo, fuerza el precio de la promoción para todas las tiendas. En caso contrario deja el habitual.',
                        'required' => 0,
                        'conditional_logic' => 0,
                        'wrapper' => array (
                            'width' => '',
                            'class' => '',
                            'id' => '',
                        ),
                    ),
                    array (
                        'default_value' => 1,
                        'message' => '',
                        'ui' => 1,
                        'ui_on_text' => '',
                        'ui_off_text' => '',
                        'key' => 'field_0pll201930818',
                        'label' => 'Dividir por subcategorías',
                        'name' => 'promo_show_subcategories',
                        'type' => 'true_false',
                        'instructions' => 'Dividir el listado por subcategorías o todos los productos juntos.',
                        'required' => 0,
                        'conditional_logic' => 0,
                        'wrapper' => array (
                            'width' => '',
                            'class' => '',
                            'id' => '',
                        ),
                    ),
	                array (
		                'default_value' => 1,
		                'message' => '',
		                'ui' => 1,
		                'ui_on_text' => '',
		                'ui_off_text' => '',
		                'key' => 'field_5977201581454',
		                'label' => 'Activa',
		                'name' => 'promo_is_active',
		                'type' => 'true_false',
		                'instructions' => '',
		                'required' => 0,
		                'conditional_logic' => 0,
		                'wrapper' => array (
			                'width' => '',
			                'class' => '',
			                'id' => '',
		                ),
                    ),
                    array (
		                'message' => '',
		                'ui' => 1,
		                'ui_on_text' => '',
		                'ui_off_text' => '',
		                'key' => 'field_5977ppllttc87',
		                'label' => 'Texto legal de promoción',
		                'name' => 'promo_legal',
		                'type' => 'wysiwyg',
		                'required' => 0,
		                'conditional_logic' => 0,
		                'wrapper' => array (
			                'width' => '',
			                'class' => '',
			                'id' => '',
		                ),
	                ),
                ),
                'location' => array (
                    array (
                        array (
                            'param' => 'taxonomy',
                            'operator' => '==',
                            'value' => WC_ALDI_TAX_PROMOS,
                        ),
                    ),
                ),
                'menu_order' => 0,
                'position' => 'normal',
                'style' => 'default',
                'label_placement' => 'top',
                'instruction_placement' => 'label',
                'hide_on_screen' => '',
                'active' => 1,
                'description' => '',
                'menu_item_level' => 'all',
            ));

        endif;

    }
    

}