<?php

namespace WCAldi\Entities;

class SealsTaxonomy {

    public function init() {

        add_action( 'init', [ $this, 'registerSealsTaxonomy' ] );
        $this->addMetaValues();

    }

    /**
     * Defining the taxonomy for wordpress
     */
    public function registerSealsTaxonomy()  {

        $labels = array(
            'name'                       => 'Sellos',
            'singular_name'              => 'Sello',
            'menu_name'                  => 'Sellos',
            'all_items'                  => 'Todos los sellos'
        );

        $args = array(
            'labels'                     => $labels,
            'hierarchical'               => false,
            'public'                     => true,
            'show_ui'                    => true,
            'show_admin_column'          => true,
            'show_in_nav_menus'          => true,
            'show_tagcloud'              => true,
        );

        register_taxonomy( WC_ALDI_TAX_SEALS, 'product', $args );
        register_taxonomy_for_object_type( WC_ALDI_TAX_SEALS, 'product' );
    }

    /**
     * Setting meta fields for the taxonomy, using plugin "Advanced Custom Fields"
     */
    public function addMetaValues() {

        if( function_exists('acf_add_local_field_group') ):

            acf_add_local_field_group(array (
                'key' => 'group_59830a091672f',
                'title' => 'Campos de taxonomía de sellos',
                'fields' => array (
                    array (
                        'key' => 'field_59830a1b62159',
                        'label' => 'Imagen',
                        'name' => 'seals_img',
                        'type' => 'image',
                        'instructions' => '',
                        'required' => 0,
                        'conditional_logic' => 0,
                        'wrapper' => array (
                            'width' => '',
                            'class' => '',
                            'id' => '',
                        ),
                        'return_format' => 'array',
                        'preview_size' => 'thumbnail',
                        'library' => 'all',
                        'min_width' => '',
                        'min_height' => '',
                        'min_size' => '',
                        'max_width' => '',
                        'max_height' => '',
                        'max_size' => '',
                        'mime_types' => '',
                    ),
                ),
                'location' => array (
                    array (
                        array (
                            'param' => 'taxonomy',
                            'operator' => '==',
                            'value' => WC_ALDI_TAX_SEALS,
                        ),
                    ),
                ),
                'menu_order' => 0,
                'position' => 'normal',
                'style' => 'default',
                'label_placement' => 'top',
                'instruction_placement' => 'label',
                'hide_on_screen' => '',
                'active' => 1,
                'description' => '',
            ));

            endif;

    }
    

}