<?php

namespace WCAldi\Managers;

class ProductFieldsManager {

    public function init() {
        
        // Fields
        add_action( 'woocommerce_product_options_inventory_product_data', [ $this, 'newFields' ] );

        // Save Fields
        add_action( 'woocommerce_process_product_meta', [ $this, 'saveFields' ] );

    }

    /**
     * HTML Code for adding the new fields under the inventory tab
     */
    public function newFields() {
        
        global $woocommerce, $post;
        
        echo '<div class="options_group">';

        woocommerce_wp_text_input( 
            array( 
                'id'          => '_aldi_family',
                'label'       => __( 'Familia ALDI', 'woocommerce' ),
                'placeholder' => '',
                'desc_tip'    => 'true',
                'description' => __( 'Puede ser WG00 o AA', 'woocommerce' )
            )
        );

        woocommerce_wp_text_input( 
            array( 
                'id'                => '_raw_code',
                'label'             => __( 'Código de producto', 'woocommerce' ),
                'placeholder'       => '',
                'type'              => 'number',
                'custom_attributes' => array(
                        'step' 	=> 'any',
                        'min'	=> '0'
                )
            )
        );
        
        echo '</div>';

    }

    /**
     * It saves the fields in the database
     */
    public function saveFields( $post_id ) {

        // Text Field
        $woocommerce_aldi_family = $_POST['_aldi_family'];
        if( !empty( $woocommerce_aldi_family ) )
            update_post_meta( $post_id, '_aldi_family', esc_attr( $woocommerce_aldi_family ) );
            
        // Number Field
        $woocommerce_raw_code = $_POST['_raw_code'];
        if( !empty( $woocommerce_raw_code ) )
            update_post_meta( $post_id, '_raw_code', esc_attr( $woocommerce_raw_code ) );

    }

}
