<?php

namespace WCAldi\Managers;

use WCAldi\Repositories\ProductPromosRepo;


class ProductsExpresMenuManager {

	public function init() {
		add_filter('nav_menu_css_class', [$this, 'addClasses'], 11, 3);
		add_filter('walker_nav_menu_start_el', [$this, 'appendHtml'], 11, 4);
	}


	function addClasses($classes, $item) {
		if (in_array('product-diasexpres-menu', $item->classes)) {
			$classes[] = 'menu-item-has-children';
		}

		return $classes;
	}


	public function appendHtml($itemOutput, $item, $depth, $args) {
		if (in_array('product-diasexpres-menu', $item->classes)) {
			$productPromosRepo = new ProductPromosRepo();
			$promos            = $productPromosRepo->getSubPromos('ideas-expres', 0, false);

			$itemOutput .= wcaldi_get_module('frontend/productsPromosMenu/productsPromosMenu', [
				'promos' => $promos
			]);
		}

		return $itemOutput;
	}
}

