<?php
/**
 * User: Sergio.Martinez
 * Date: 22/09/2017
 * Time: 11:01
 */

namespace WCAldi\Managers;


use WCAldi\Repositories\ProductCategoriesRepo;

class ProductsMegaMenuManager {

	public function init() {
		add_filter( 'nav_menu_css_class', [ $this, 'addClasses' ], 10, 3 );
		add_filter( 'walker_nav_menu_start_el', [ $this, 'appendHtml' ], 10, 4 );
	}

	function addClasses( $classes, $item ) {
		if ( in_array( 'product-categories-mega-menu', $item->classes ) ) {
			$classes[] = 'menu-item-has-children';
		}

		return $classes;
	}

	public function appendHtml( $item_output, $item, $depth, $args ) {

		if ( in_array( 'product-categories-mega-menu', $item->classes ) ) {

			$productCategoriesrepo = new ProductCategoriesRepo();
			$categories            = $productCategoriesrepo->getCompleteCategoryTree();

			$categories = [$categories[0]];

			$item_output .= wcaldi_get_module( 'frontend/productsMegaMenu/productsMegaMenu', [
				'categories' => $categories,
				'depth'      => 3
			] );
		}

		return $item_output;
	}

}