<?php
/**
 * Generated by the WordPress Option Page generator
 * at http://jeremyhixon.com/wp-tools/option-page/
 */

namespace WCAldi\OptionPages;

use WCAldi\MassiveImporter\MassiveProductsImporter;
use WCAldi\Exporter\ProductsExporter;
use WCAldi\Cache\ProductsCache;

class IMAImportOptionPage {

	private $ima_import_options, $menu_hook;

	public function init() {

		add_action( 'admin_menu', array( $this, 'ima_import_add_plugin_page' ) );
		add_action( 'admin_init', array( $this, 'ima_import_page_init' ) );

		// Datepicker
		add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_styles_scripts' ) );

		// "Import now" Button
		add_action( 'wp_ajax_importNow', array( $this, 'importNow' ));
		add_action( 'wp_ajax_nopriv_importNow', array( $this, 'importNow' ));

		// "Cancel import" Button
		add_action( 'wp_ajax_cancelImport', array( $this, 'cancelImport' ));
		add_action( 'wp_ajax_nopriv_cancelImport', array( $this, 'cancelImport' ));

	}
	

	public function ima_import_add_plugin_page() {

		$this->menu_hook = add_submenu_page(
			'edit.php?post_type=product', // parent_slug
			'Importación desde IMA', // page_title
			'Importación desde IMA', // menu_title
			'manage_options', // capability
			'importacion-desde-ima', // menu_slug,
			array( $this, 'ima_import_create_admin_page' ) // function
		);

		// Creating cron on save
		add_action( 'load-'.$this->menu_hook, array( $this,'ima_import_schedule_on_save' ) );
	}

	public function ima_import_create_admin_page() {
		$this->ima_import_options = get_option( 'ima_import_options' ); ?>

		<div class="wrap">
			<h2>Importación automática desde IMA</h2>
			<p>Configuración de las opciones de importación automática desde IMA.</p>
			<?php settings_errors(); ?>

			<form method="post" action="options.php">
				<?php
					settings_fields( 'ima_import_option_group' );
					do_settings_sections( 'importacion-desde-ima-admin' );
					// Tiempo de cron
					if( wp_next_scheduled('ima_import_cron') ) { // Getting next time the cron will run
					  echo "La próxima importación se realizará automáticamente el <strong>".date("d/m/Y - G:i",wp_next_scheduled('ima_import_cron'))."</strong><br>Deja vacía la fecha para evitar que se ejecute el importador automáticamente.";
					} else {
					  echo "<div class='alert'>No hay una fecha esperada para la próxima importación de productos.<br><strong>Por favor, rellene los campos superiores y presione 'Guardar cambios'.</strong></div>";
					}

					submit_button();
				?>
			</form>

			<div class="ima_import_options_page">
				<div class="ima_import_options_page_loading">Importando productos... Este proceso continuará ejecutándose en segundo plano y podría tardar. <img src="<?php echo wcaldi_get_asset("img/backend/loader.gif"); ?>"></div>
				<h3>Importar ahora</h3>
				<button class="ima_import_options_page_import" data-products="all">Importar todos</button> <button class="ima_import_options_page_import" data-products="24">Importar actualizados últimas 24h</button>
				<?php
				$massiveImporter = new \WCAldi\MassiveImporter\MassiveProductsImporter;
				$ima_import_status = $massiveImporter->getImportStatus();
				if( $ima_import_status ) {
				?>
					 <button class="ima_import_options_page_import_cancel">Cancelar importación</button>
				<?php
				}
				?>
				<div class="ima_import_options_page_messages"></div>
			</div>

			<h3>Últimos movimientos</h3>
			<div class="ima_import_log">
				<p>
					<?php
					$MassiveImporter = new MassiveProductsImporter;
					$MassiveImporter->printUpdatesLog();
					?>
				</p>
			</div>

		</div>
	<?php }

	public function ima_import_page_init() {

		register_setting(
			'ima_import_option_group', // option_group
			'ima_import_options', // option_name
			array( $this, 'ima_import_sanitize' ) // sanitize_callback
		);

		add_settings_section(
			'ima_import_setting_section', // id
			'Settings', // title
			array( $this, 'ima_import_section_info' ), // callback
			'importacion-desde-ima-admin' // page
		);

		add_settings_field(
			'ima_import_periodicity', // id
			'Periodicidad', // title
			array( $this, 'periodicity_callback' ), // callback
			'importacion-desde-ima-admin', // page
			'ima_import_setting_section' // section
		);

		add_settings_field(
			'ima_import_start_date', // id
			'Fecha de comienzo', // title
			array( $this, 'start_date_callback' ), // callback
			'importacion-desde-ima-admin', // page
			'ima_import_setting_section' // section
		);

		add_settings_field(
			'ima_import_ima_url', // id
			'URL de importación', // title
			array( $this, 'ima_url_callback' ), // callback
			'importacion-desde-ima-admin', // page
			'ima_import_setting_section' // section
		);

		add_settings_field(
			'ima_import_ima_images', // id
			'Establecer imágenes como subidas', // title
			array( $this, 'ima_images_callback' ), // callback
			'importacion-desde-ima-admin', // page
			'ima_import_setting_section' // section
		);

		add_settings_field(
			'ima_import_ima_apikey', // id
			'APIKey', // title
			array( $this, 'ima_apikey_callback' ), // callback
			'importacion-desde-ima-admin', // page
			'ima_import_setting_section' // section
		);
		
	}

	public function ima_import_sanitize($input) {
		$sanitary_values = array();
		if ( isset( $input['ima_import_periodicity'] ) ) {
			$sanitary_values['ima_import_periodicity'] = $input['ima_import_periodicity'];
		}

		if ( isset( $input['ima_import_start_date'] ) ) {
			$sanitary_values['ima_import_start_date'] = sanitize_text_field( $input['ima_import_start_date'] );
		}

		if ( isset( $input['ima_import_ima_url'] ) ) {
			$sanitary_values['ima_import_ima_url'] = sanitize_text_field( $input['ima_import_ima_url'] );
		}

		if ( isset( $input['ima_import_ima_images'] ) ) {
			$sanitary_values['ima_import_ima_images'] = sanitize_text_field( $input['ima_import_ima_images'] );
		}

		if ( isset( $input['ima_import_ima_apikey'] ) ) {
			$sanitary_values['ima_import_ima_apikey'] = sanitize_text_field( $input['ima_import_ima_apikey'] );
		}

		return $sanitary_values;
	}

	public function ima_import_section_info() {
		
	}

	public function ima_import_schedule_on_save() {

		if( isset($_GET['settings-updated']) && $_GET['settings-updated'] ) {
			wp_clear_scheduled_hook( 'ima_import_cron' );
			$this->ima_import_scheduler();
		}

	}

	public function ima_import_scheduler() {
		
		$options = get_option( 'ima_import_options' );

		if( $options['ima_import_periodicity'] ) {
			$periodicity = $options['ima_import_periodicity']; // Getting the time range
		} else {
			$periodicity = "daily";
		}

		if( $options['ima_import_start_date'] ) {
			$start_date = strtotime( $options['ima_import_start_date'] );
		} else {
			$start_date = null;
		}

		if ( ! wp_next_scheduled( 'ima_import_cron' ) && $start_date != null ) {
			wp_schedule_event( $start_date, $periodicity, 'ima_import_cron' );
		}

	}

	public function periodicity_callback() {
		?> <select name="ima_import_options[ima_import_periodicity]" id="ima_import_periodicity">
			<?php $selected = (isset( $this->ima_import_options['ima_import_periodicity'] ) && $this->ima_import_options['ima_import_periodicity'] === 'hourly') ? 'selected' : '' ; ?>
			<option value="hourly" <?php echo $selected; ?>>Cada hora</option>
			<?php $selected = (isset( $this->ima_import_options['ima_import_periodicity'] ) && $this->ima_import_options['ima_import_periodicity'] === 'twicedaily') ? 'selected' : '' ; ?>
			<option value="twicedaily" <?php echo $selected; ?>>Dos veces al día</option>
			<?php $selected = (isset( $this->ima_import_options['ima_import_periodicity'] ) && $this->ima_import_options['ima_import_periodicity'] === 'daily') ? 'selected' : '' ; ?>
			<option value="daily" <?php echo $selected; ?>> Diariamente</option>
			<?php $selected = (isset( $this->ima_import_options['ima_import_periodicity'] ) && $this->ima_import_options['ima_import_periodicity'] === 'weekly') ? 'selected' : '' ; ?>
			<option value="weekly" <?php echo $selected; ?>> Semanalmente</option>
			<?php $selected = (isset( $this->ima_import_options['ima_import_periodicity'] ) && $this->ima_import_options['ima_import_periodicity'] === 'monthly') ? 'selected' : '' ; ?>
			<option value="monthly" <?php echo $selected; ?>> Mensualmente</option>
		</select> <?php
	}

	public function start_date_callback() {
		printf(
			'<input class="regular-text datetimepicker" type="text" name="ima_import_options[ima_import_start_date]" id="ima_import_start_date" value="%s">',
			isset( $this->ima_import_options['ima_import_start_date'] ) ? esc_attr( $this->ima_import_options['ima_import_start_date']) : ''
		);
	}

	public function ima_url_callback() {
		printf(
			'<input class="regular-text" type="text" name="ima_import_options[ima_import_ima_url]" id="ima_import_ima_url" value="%s">',
			isset( $this->ima_import_options['ima_import_ima_url'] ) ? esc_attr( $this->ima_import_options['ima_import_ima_url']) : ''
		);
	}

	public function ima_images_callback() {
		printf(
			'<input class="regular-text" type="checkbox" name="ima_import_options[ima_import_ima_images]" id="ima_import_ima_images" %s>',
			isset( $this->ima_import_options['ima_import_ima_images'] ) ? 'checked' : ''
		);
	}

	public function ima_apikey_callback() {
		printf(
			'<input class="regular-text" type="text" name="ima_import_options[ima_import_ima_apikey]" id="ima_import_ima_apikey" value="%s">',
			isset( $this->ima_import_options['ima_import_ima_apikey'] ) ? esc_attr( $this->ima_import_options['ima_import_ima_apikey']) : ''
		);
	}

	function admin_footer() {
		
		$screen = get_current_screen();
	
		if ( $screen->id == 'settings_page_plugin-name' ) {
	
			?><script type="text/javascript">
				jQuery(document).ready(function(){
					jQuery('.datepicker').datepicker({
						dateFormat : 'D, m/d/yy'
					});
				});
			</script><?php
			
		}
	
	}

	function my_add_intervals( $schedules ) {
		// add a 'weekly' interval
		$schedules['weekly'] = array(
			'interval' => 604800,
			'display' => __('Once Weekly')
		);
		$schedules['monthly'] = array(
			'interval' => 2635200,
			'display' => __('Once a month')
		);
		return $schedules;
	}
	
	// Execute the script to import the products
	public function importNow() {
	
		check_ajax_referer( 'wc_aldi_import-ajax', 'security' );

		$modality = $_POST['productTiming'];
		$massiveImporter = new MassiveProductsImporter();

		if( $modality == 'all' ) {

			$massiveImporter->importIMAProducts();

		} else {

			$massiveImporter->importIMAProductsLastHours( $modality );

		}

		$return = [
			'status' => 'success',
			'message' => '¡Bien! La importación ha finalizado correctamente.'
		];
		wp_send_json( $return );
		die(); // Wordpress requeriment for using AJAX

	}

	/**
	 * Cancel import
	 */
	public function cancelImport() {

		check_ajax_referer( 'wc_aldi_import-ajax', 'security' );

		$productsExporter = new ProductsExporter();
		$productsExporter->generateJson();

		$massiveImporter = new MassiveProductsImporter();
		$massiveImporter->setImportStatus( 0 );

		die();

	}
	
	/**
	 * Enqueues the built-in Datepicker script
	 * Only loads on the plugin-name settings page
	 */
	function enqueue_styles_scripts( ) {
	
		wp_enqueue_style( 'jquery-admin-datepicker', WC_ALDI_PLUGIN_URL . '/vendor/datepicker/jquery.datetimepicker.min.css', array(), null );
		wp_enqueue_style( 'jquery-admin-datepicker-styles', WC_ALDI_PLUGIN_URL . '/app/OptionPages/IMAImportOptionPageAdmin.css', array(), null );
		wp_enqueue_script( 'jquery-admin-datepicker', WC_ALDI_PLUGIN_URL . '/vendor/datepicker/jquery.datetimepicker.full.min.js', array( 'jquery' ), '', true );
		wp_enqueue_script( 'wc-aldi-import-scripts', WC_ALDI_PLUGIN_URL . '/app/OptionPages/IMAImportOptionPageAdmin.js', array( 'jquery', 'jquery-admin-datepicker' ), '', true );

		wp_localize_script( 'wc-aldi-import-scripts', 'WC_Aldi_import', array(
			// URL to wp-admin/admin-ajax.php to process the request
		
			'ajaxurl' => admin_url( 'admin-ajax.php' ),
		
			// generate a nonce with a unique ID "myajax-post-comment-nonce"
			// so that you can check it later when an AJAX request is sent
			'security' => wp_create_nonce( 'wc_aldi_import-ajax' )
	
		));
	}

}
	

/* 
 * Retrieve this value with:
 * $ima_import_options = get_option( 'ima_import_options' ); // Array of All Options
 * $periodicity = $ima_import_options['ima_import_periodicity']; // Periodicity
 * $start_date = $ima_import_options['ima_import_start_date']; // Start date
 */
