<?php
/**
 * Generated by the WordPress Option Page generator
 * at http://jeremyhixon.com/wp-tools/option-page/
 */

namespace WCAldi\OptionPages;

use WCAldi\Cache\ProductsCache;

class ProductsCacheOptionPage {

	private $products_cache_options, $menu_hook;

	public function init() {

		add_action( 'admin_menu', array( $this, 'products_cache_add_plugin_page' ) );
		add_action( 'admin_init', array( $this, 'products_cache_page_init' ) );

        // Cache regenerate post
		add_action( 'admin_post_regenerate_products_cache', array( $this, 'regenerateProductsCache' ));

	}

	public function products_cache_add_plugin_page() {

		$this->menu_hook = add_submenu_page(
			'edit.php?post_type=product', // parent_slug
			'Caché Productos', // page_title
			'Caché Productos', // menu_title
			'manage_options', // capability
			'cache-productos', // menu_slug,
			array( $this, 'products_cache_create_admin_page' ) // function
		);

		// Creating cron on save
		add_action( 'load-'.$this->menu_hook, array( $this,'products_cache_schedule_on_save' ) );
	}

	public function products_cache_create_admin_page() {
		$this->products_cache_options = get_option( 'products_cache_options' ); ?>

		<div class="wrap">
			<h2>Caché de productos</h2>
			<p>En caso de estar activada, la caché se generará automáticamente cada vez que se realice una importación masiva de productos (usualmente cada madrugada).
			<?php settings_errors(); ?>

			<form method="post" action="options.php">
				<?php
					settings_fields( 'products_cache_option_group' );
					do_settings_sections( 'cache-productos-admin' );
					// Tiempo de cron
					// if( wp_next_scheduled('products_cache_cron') ) { // Getting next time the cron will run
					//   echo "La caché volverá a regenerarse automáticamente el <strong>".date("d/m/Y - G:i",wp_next_scheduled('products_cache_cron'))."</strong><br>Deja vacía la fecha para evitar que se genere automáticamente.";
					// } else {
					//   echo "<div class='alert'>No hay una fecha esperada para generar la caché.<br><strong>Por favor, rellene los campos superiores y presione 'Guardar cambios'.</strong></div>";
					// }

					submit_button();
				?>
			</form>

            <div class="ima_import_regenerate_cache">
				<h3>Generación instantánea</h3>

				<?php if ($_GET['ok_regenerate_cache']): ?>
					<div class="products_menu_options_page_messages">
						Se ha regenerado la caché.
					</div>
				<?php endif ?>

				<form action="<?= admin_url('admin-post.php') ?>" method="post">
					<input type="hidden" name="action" value="regenerate_products_cache">

					<?php submit_button('Regenerar caché') ?>
				</form>
			</div>

		</div>
    <?php
    }

	public function products_cache_page_init() {

		register_setting(
			'products_cache_option_group', // option_group
			'products_cache_options', // option_name
			array( $this, 'products_cache_sanitize' ) // sanitize_callback
		);

		add_settings_section(
			'products_cache_setting_section', // id
			'Settings', // title
			array( $this, 'products_cache_section_info' ), // callback
			'cache-productos-admin' // page
		);

		add_settings_field(
			'products_cache_activate', // id
			'Activar caché', // title
			array( $this, 'activate_callback' ), // callback
			'cache-productos-admin', // page
			'products_cache_setting_section' // section
        );
        
		// add_settings_field(
		// 	'products_cache_periodicity', // id
		// 	'Periodicidad', // title
		// 	array( $this, 'periodicity_callback' ), // callback
		// 	'cache-productos-admin', // page
		// 	'products_cache_setting_section' // section
		// );

		// add_settings_field(
		// 	'products_cache_start_date', // id
		// 	'Fecha de comienzo', // title
		// 	array( $this, 'start_date_callback' ), // callback
		// 	'cache-productos-admin', // page
		// 	'products_cache_setting_section' // section
		// );
		
	}

	public function products_cache_sanitize($input) {

        $sanitary_values = array();
        
		if ( isset( $input['products_cache_activate'] ) ) {
			$sanitary_values['products_cache_activate'] = $input['products_cache_activate'];
        }
        
		// if ( isset( $input['products_cache_periodicity'] ) ) {
		// 	$sanitary_values['products_cache_periodicity'] = $input['products_cache_periodicity'];
		// }

		// if ( isset( $input['products_cache_start_date'] ) ) {
		// 	$sanitary_values['products_cache_start_date'] = sanitize_text_field( $input['products_cache_start_date'] );
        // }
        
		return $sanitary_values;
	}

	public function products_cache_section_info() {
		
	}

	public function products_cache_schedule_on_save() {

		if( isset($_GET['settings-updated']) && $_GET['settings-updated'] ) {
			wp_clear_scheduled_hook( 'products_cache_cron' );
			$this->products_cache_scheduler();
		}

	}

	public function products_cache_scheduler() {
		
		$options = get_option( 'products_cache_options' );

		if( $options['products_cache_periodicity'] ) {
			$periodicity = $options['products_cache_periodicity']; // Getting the time range
		} else {
			$periodicity = "daily";
		}

		if( $options['products_cache_start_date'] ) {
			$start_date = strtotime( $options['products_cache_start_date'] );
		} else {
			$start_date = null;
		}

		if ( ! wp_next_scheduled( 'products_cache_cron' ) && $start_date != null ) {
			wp_schedule_event( $start_date, $periodicity, 'products_cache_cron' );
		}

    }
    
    public function activate_callback() {

        printf(
			'<input type="checkbox" name="products_cache_options[products_cache_activate]" id="products_cache_activate" value="products_cache_activate" %s>',
			( isset( $this->products_cache_options['products_cache_activate'] ) && $this->products_cache_options['products_cache_activate'] === 'products_cache_activate' ) ? 'checked' : ''
		);
    }

	public function periodicity_callback() {
		?> <select name="products_cache_options[products_cache_periodicity]" id="products_cache_periodicity">
			<?php $selected = (isset( $this->products_cache_options['products_cache_periodicity'] ) && $this->products_cache_options['products_cache_periodicity'] === 'hourly') ? 'selected' : '' ; ?>
			<option value="hourly" <?php echo $selected; ?>>Cada hora</option>
			<?php $selected = (isset( $this->products_cache_options['products_cache_periodicity'] ) && $this->products_cache_options['products_cache_periodicity'] === 'twicedaily') ? 'selected' : '' ; ?>
			<option value="twicedaily" <?php echo $selected; ?>>Dos veces al día</option>
			<?php $selected = (isset( $this->products_cache_options['products_cache_periodicity'] ) && $this->products_cache_options['products_cache_periodicity'] === 'daily') ? 'selected' : '' ; ?>
			<option value="daily" <?php echo $selected; ?>> Diariamente</option>
			<?php $selected = (isset( $this->products_cache_options['products_cache_periodicity'] ) && $this->products_cache_options['products_cache_periodicity'] === 'weekly') ? 'selected' : '' ; ?>
			<option value="weekly" <?php echo $selected; ?>> Semanalmente</option>
			<?php $selected = (isset( $this->products_cache_options['products_cache_periodicity'] ) && $this->products_cache_options['products_cache_periodicity'] === 'monthly') ? 'selected' : '' ; ?>
			<option value="monthly" <?php echo $selected; ?>> Mensualmente</option>
		</select> <?php
	}

	public function start_date_callback() {
		printf(
			'<input class="regular-text datetimepicker" type="text" name="products_cache_options[products_cache_start_date]" id="products_cache_start_date" value="%s">',
			isset( $this->products_cache_options['products_cache_start_date'] ) ? esc_attr( $this->products_cache_options['products_cache_start_date']) : ''
		);
    }
	
    /**
	 * Regenerating products cache when the button is pressed
	 */
	public function regenerateProductsCache() {
        
        $productsCache = new ProductsCache();
        $productsCache->saveCache();

        $redirect = admin_url() . '/edit.php?post_type=product&page=cache-productos&ok_regenerate_cache=1';
        header("Location: $redirect");

    }

}
	

/* 
 * Retrieve this value with:
 * $products_cache_options = get_option( 'products_cache_options' ); // Array of All Options
 * $periodicity = $products_cache_options['products_cache_periodicity']; // Periodicity
 * $start_date = $products_cache_options['products_cache_start_date']; // Start date
 */
