<?php
/**
 * Generated by the WordPress Option Page generator
 * at http://jeremyhixon.com/wp-tools/option-page/
 */

namespace WCAldi\OptionPages;

use WCAldi\Repositories\ProductCategoriesRepo;


class ProductsMenuGeneratorOptionPage {

	private $menu_hook;

	public function init() {
		add_action('admin_menu', array($this, 'products_menu_add_plugin_page'));
		add_action('admin_post_regenerate', array($this, 'products_menu_regenerate'));
		add_action('admin_enqueue_scripts', array($this, 'enqueue_styles_scripts'));
	}


	public function products_menu_add_plugin_page() {
		$this->menu_hook = add_submenu_page(
			'edit.php?post_type=product', // parent_slug
			'Menú Productos', // page_title
			'Menú Productos', // menu_title
			'manage_options', // capability
			'menu-productos', // menu_slug,
			array($this, 'products_menu_create_admin_page') // function
		);
	}


	public function products_menu_create_admin_page() {
		$this->products_menu_options = get_option('products_menu_options');

		?>
			<div class="wrap">
            	<h2>Menú de productos</h2>

				<?php if ($_GET['ok']): ?>
					<div class="products_menu_options_page_messages">
						Se ha regenerado el menú.
					</div>
				<?php endif ?>

        	    <p>El menú de "Nuestros productos" de la web se forma automáticamente con las categorías de la web. Sin embargo, hay un sistema de caché para aumentar la velocidad. Desde aquí puedes regenerar el menú de productos si has eliminado, añadido o editado categorías.</p>
				<?php settings_errors() ?>

				<form action="<?= admin_url('admin-post.php') ?>" method="post">
					<input type="hidden" name="action" value="regenerate">

					<?php submit_button('Regenerar') ?>
				</form>
			</div>
		<?php
	}


	public function products_menu_regenerate() {
		$productCategoriesRepo = new ProductCategoriesRepo();
		$productCategoriesRepo->saveCompleteCategoryTree();

		$redirect = admin_url() . '/edit.php?post_type=product&page=menu-productos&ok=1';
		header("Location: $redirect");

		die(__FUNCTION__);
	}


	/**
	 * Enqueues the built-in Datepicker script
	 * Only loads on the plugin-name settings page
	 */
	function enqueue_styles_scripts() {
		wp_enqueue_style(
			'jquery-admin-menu-generator-styles',
			WC_ALDI_PLUGIN_URL . '/app/OptionPages/ProductsMenuGeneratorOptionPage.css',
			array(),
			null
		);
	}
}

