<?php
/**
 * Generated by the WordPress Option Page generator
 * at http://jeremyhixon.com/wp-tools/option-page/
 */

namespace WCAldi\OptionPages;

use WCAldi\Repositories\StoreRepo;
use WCAldi\Managers\StoreSelectorManager;


class StoreSelectorGeneratorOptionPage {

	private $menu_hook;

	public function init() {
		add_action('admin_menu', array($this, 'stores_selector_add_plugin_page'));
		add_action('admin_post_stores_selector_regenerate', array($this, 'stores_selector_regenerate'));
		add_action('admin_enqueue_scripts', array($this, 'enqueue_styles_scripts'));
	}


	public function stores_selector_add_plugin_page() {
		$this->menu_hook = add_submenu_page(
			'edit.php?post_type=tienda', // parent_slug
			'Actualizar selector tiendas', // page_title
			'Actualizar selector tiendas', // menu_title
			'manage_options', // capability
			'menu-tiendas', // menu_slug,
			array($this, 'stores_selector_create_admin_page') // function
		);
	}


	public function stores_selector_create_admin_page() {

		?>
			<div class="wrap">
            	<h2>Selector de tiendas</h2>

				<?php if ($_GET['ok']): ?>
					<div class="stores_selector_options_page_messages">
						Se han regenerado las tiendas del selector.
					</div>
				<?php endif ?>

        	    <p>Desde aquí puedes regenerar las tiendas que aparecen en el selector.</p>
				<?php settings_errors() ?>

				<form action="<?= admin_url('admin-post.php') ?>" method="post">
					<input type="hidden" name="action" value="stores_selector_regenerate">

					<?php submit_button('Regenerar') ?>
				</form>
			</div>
		<?php
	}


	public function stores_selector_regenerate() {
		$storeSelectorManager = new StoreSelectorManager();
		$storeSelectorManager->saveStores();

		$redirect = admin_url() . '/edit.php?post_type=tienda&page=menu-tiendas&ok=1';
		header("Location: $redirect");

		die(__FUNCTION__);
	}


	/**
	 * Enqueues the built-in Datepicker script
	 * Only loads on the plugin-name settings page
	 */
	function enqueue_styles_scripts() {
		wp_enqueue_style(
			'jquery-admin-store-selector-styles',
			WC_ALDI_PLUGIN_URL . '/app/OptionPages/StoreSelectorGeneratorOptionPage.css',
			array(),
			null
		);
	}
}

