<?php

namespace WCAldi\PrettyUrl;

class PrettyJsons {

    public function init() {
        
        // URL Rewriting
        add_action( 'init', [ $this, 'jsonUrlRewriting'], 10, 0);

        add_filter( 'query_vars', [ $this, 'addParamsQueryVar' ] );

    }

    /**
     * It rewrites the URL to admit parameters for the product filters
     */
    public function jsonUrlRewriting() {

        global $wp_rewrite;

        // Rewrite rule for the category's page
        add_rewrite_rule('^products-json/product-type/(.*)',
                        'index.php?product_type=$matches[1]',
                        'top');

        $wp_rewrite->flush_rules(true);

    }

    // Add `Params` to query vars
    public function addParamsQueryVar( $vars )
    {
        $vars[] = "product_type";
        return $vars;
    }

}