<?php

namespace WCAldi\Printers;

use WCAldi\Repositories\ProductCategoriesRepo;

class SearchProductPrinters {

	/**
	 * It prints the categories and subcategories together with their products
	 *
	 * @param array $products
	 */
	public function printProducts($products) {
		if (!empty($products)) {
			echo "<div class='woocommerce-archive-categories-wrapper'>";

			echo get_component(
				'woocommerce/woocommerce-archive-categories/woocommerce-archive-categories',
				['products' => [0 => ['products' => $products]], 'urlParams' => '']
			);

			echo "</div>";
		} else {
			$result = woocommerce_product_subcategories([
				'before' => woocommerce_product_loop_start(false),
				'after'  => woocommerce_product_loop_end(false)
			]);

			if (!$result) {
				/*
				 * woocommerce_no_products_found hook.
				 *
				 * @hooked wc_no_products_found - 10
				 */
				do_action('woocommerce_no_products_found');
			}
		}
	}
}
