<?php

namespace WCAldi\Repositories;

use WCAldi\Repositories\TaxonomyRepo;

class SealsRepo {

    protected $seals;

    /**
     * It returns all the existing seals
     *
	 * @return array
     */
    public function getAll() {

        $terms = get_terms( array(
            'taxonomy' => WC_ALDI_TAX_SEALS,
            'hide_empty' => false,
        ));

        $i = 0;
        $seals = [];
        foreach( $terms as $t ) {
            $seals[$i] = (array) $t;
            $seals[$i]['img']['url'] =  get_field('seals_img', WC_ALDI_TAX_SEALS . '_' . $t->term_id )['url'];
            $seals[$i]['img']['alt'] =  get_field('seals_img', WC_ALDI_TAX_SEALS . '_' . $t->term_id )['alt'];
            $i++;
        }

        return $seals;

    }

    /**
     * It returns the seals of a single product
     *
     * @param int $product_id
     *
	 * @return array of the terms
     */
    public function getProductSeals( $product_id ) {

        $terms = wp_get_post_terms( $product_id, WC_ALDI_TAX_SEALS, array() );

        $i = 0;
        $seals = [];
        foreach( $terms as $t ) {
            $seals[$i] = (array) $t;
            $seals[$i]['img']['url'] =  get_field('seals_img', WC_ALDI_TAX_SEALS . '_' . $t->term_id )['url'];
            $seals[$i]['img']['alt'] =  get_field('seals_img', WC_ALDI_TAX_SEALS . '_' . $t->term_id )['alt'];
            $i++;
        }

        return $seals;

    }

    /**
     * It deletes the current existing seals for a product, and adds the new one
     *
     * @param int $product_id
     * @param array $seals - An array of names of the seals
     */
    public function setProductSeals( $product_id, $seals ) {

        $product_tax = new TaxonomyRepo();
        $product_tax->setProductTaxonomies( $product_id, $seals, WC_ALDI_TAX_SEALS ); // We use this function for selecting the promos the product belongs to

    }

}