<?php

DEFINE( 'WC_ALDI_PLUGIN_URL', plugin_dir_url( dirname( dirname( __FILE__ ) ) ) );
DEFINE( 'WC_ALDI_PLUGIN_PATH', plugin_dir_path( dirname( dirname( __FILE__) ) ) );

DEFINE( 'WC_ALDI_LOG_FILE', 'update-products' );

function wcaldi_get_product_by_sku( $sku ) {
	global $wpdb;

	$product_id = $wpdb->get_var( $wpdb->prepare( "SELECT post_id FROM $wpdb->postmeta WHERE meta_key='_sku' AND meta_value='%s' LIMIT 1", $sku ) );

	if ( $product_id ) {
		return new WC_Product( $product_id );
	}

	return null;
}

function wcaldi_get_product_id_by_sku( $sku ) {
	global $wpdb;

	$product_id = $wpdb->get_var( $wpdb->prepare( "SELECT post_id FROM $wpdb->postmeta WHERE meta_key='_sku' AND meta_value='%s' LIMIT 1", $sku ) );

	if ( $product_id ) {
		return $product_id;
	}

	return null;
}

function wcaldi_get_module( $componentPath, $params = [] ) {
	extract( $params );

	ob_start();
	include WC_ALDI_PLUGIN_PATH . 'modules/' . $componentPath . '.php';
	$output = ob_get_clean();

	return $output;
}

function wcaldi_get_asset( $assetPath ) {
	return WC_ALDI_PLUGIN_URL . 'assets/' . $assetPath;
}

/**
 * It returns an array with the data of the categories with certain name
 *
 * @param $name - Name of the taxonomy
 * @param $taxonomy_type - Type of the taxonomy, for example 'product_cat'.
 *
 * @return array
 */
function wcaldi_get_taxonomies_by_name( $name, $taxonomy_type ) {

	global $wpdb;

	$term_id = $wpdb->get_results( $wpdb->prepare( "SELECT term_id FROM $wpdb->terms WHERE name='%s' AND term_id IN (SELECT term_id FROM $wpdb->term_taxonomy WHERE taxonomy = '%s')", $name, $taxonomy_type ), OBJECT );

	$termsArray = [];
	if ( $term_id ) {

		foreach( $term_id as $t ) {
			$termsArray[] = get_term_by( 'id', $t->term_id, $taxonomy_type );
		}
		return $termsArray;
	}

	return false;

}
