<?php

namespace WCAldi\Widgets;

use WCAldi\Repositories\ProductCategoriesRepo;
use WCAldi\PrettyUrl\PrettyFilters;

// Creating the widget for the button
class ArchiveFilterWidget extends \WP_Widget {

    function __construct() {
        parent::__construct(

        // Base ID of your widget
        'wcaldi_archive_filter_widget', 

        // Widget name will appear in UI
        __('WCAldi - Filtro de productos', 'wcaldi'), 

        // Widget description
        array( 'description' => __( 'Filtra los productos mediante AJAX.', 'wcaldi' ), ) 
        );
    }

    // Creating widget front-end
    public function widget( $args, $instance ) {

        global $wp_query;

        // before and after widget arguments are defined by themes
        echo $args['before_widget'];

        $cate = get_queried_object();
        $productCategories = new ProductCategoriesRepo();

        $prettyFilter = new PrettyFilters();

        // Getting filters from the URL
        if( isset($wp_query->query_vars['filter_products']) ) {
            $params['filters'] = $prettyFilter->parseFilterProducts( $wp_query->query_vars['filter_products'] );
        }

        $params['categories'] = $productCategories->getSubcategories( $cate->term_id );
        $params['current_category']['id'] = $cate->term_id;
        $params['current_category']['name'] = single_cat_title('', false); // for printing current category
        
        // This is where you run the code and display the output
        echo wcaldi_get_module( 'frontend/archiveFilter/archiveFilter', $params);

        echo $args['after_widget'];
    }

    // Updating widget replacing old instances with new
    public function update( $new_instance, $old_instance ) {
        $instance = array();
        $instance['title'] = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
        return $instance;
    }


} // Class wpb_widget ends here