jQuery(document).ready(function ($) {

    addDatepicker();
    validationSavingProduct();
    //onlyOnePromoAtATime();
    returnToOkWhenChange();

    $('.availability-button_check-all').on('click', function() {
        setStoresAvailability(true);
    });
    $('.availability-button_uncheck-all').on('click', function() {
        setStoresAvailability(false);
    });

    $('.actions__button--copy-price').on('click', copyPrices);
    $('.actions__button--copy-calc-price').on('click', copyPrices);
});


// It adds a datepicker to certain fields
function addDatepicker() {

    jQuery(".datepicker-product").each(function (index) {
        var datepicker_default_val = jQuery(this).val();
        jQuery(this).datepicker();
        jQuery(this).datepicker("option", "dateFormat", 'yy-mm-dd');
        jQuery(this).datepicker("setDate", datepicker_default_val);
    });

}

// It checks if there's some promotion checked
function checkPromoActive() {

    checked = 0;

    jQuery('#taxonomy-' + WC_ALDI.name_tax + ' input').each(function () {

        if (jQuery(this).is(':checked')) {
            checked++;
        }
    });

    return checked;
}

// Allowing only one promo to be active
function onlyOnePromoAtATime() {

    jQuery('#taxonomy-' + WC_ALDI.name_tax + ' input').on('change', function () {
        if (checkPromoActive() > 1) {
            alert("Sólo es posible tener una promoción al mismo tiempo");
            jQuery(this).attr('checked', false);
        }
    });

}

// It checks if the data of the promotions tab are filled
function checkPromoTabIsFilled() {

    empty = false;

    startDate = jQuery('#product_promos_data #wcaldi_promo_startdate');
    endDate = jQuery('#product_promos_data #wcaldi_promo_enddate');

    if (startDate.val() == '') {
        startDate.css({ 'background-color': '#ffdfdf' });
        empty = true;
    }

    if (endDate.val() == '') {
        endDate.css({ 'background-color': '#ffdfdf' });
        empty = true;
    }

    return empty;

}

// It takes back the styles of the fields when the user writes in them
function returnToOkWhenChange() {

    startDate = jQuery('#product_promos_data #wcaldi_promo_startdate');
    endDate = jQuery('#product_promos_data #wcaldi_promo_enddate');

    startDate.on('change paste keyup', function () {
        jQuery(this).css({ 'background-color': 'white' });
    });

    endDate.on('change paste keyup', function () {
        jQuery(this).css({ 'background-color': 'white' });
    });

}

// It adds a validation when we press save
function validationSavingProduct() {

    jQuery('#post').submit(function () {

        if (checkPromoActive() != false) {

            if (checkPromoTabIsFilled()) {

                alert("Hay una promo activa pero los datos están incompletos. Por favor, rellene los datos dentro de la pestaña 'Promociones");

                return false;

            }

        }

    });

}

// Product store availability check/uncheck all
function setStoresAvailability(value) {
    $('#product_store_data').find('input[type=checkbox]').attr('checked', value);
}

// copy data from sibling input to given target class if available
function copyPrices() {
    const ele = $(this);
    var value = ele.parent().find('input')[0].value;

    $('#product_store_data .' + ele.data('target')).each(function(index, item){
        item = $(item);
        if(item.parent().parent().find('input[type=checkbox]').is(':checked')) {
            item.val(value);
        }
    });
}
