jQuery(window).load(function () {

    isGeolocationActive();
    showingStoresOnModal();

});

jQuery(document).ready(function ($) {

    definingStoreSelectorModal();
    startingStoreSelectorGeocomplete();

});

function definingStoreSelectorModal() {

    jQuery('.wcaldi-store-selector-right').on('click', function () {
        jQuery('.store-selector-modal').modal({
            backdrop: 'static',
            keyboard: false
        });

        jQuery('.store-selector-modal .modal-header .close').css({'display':'block'});
    });

    if( jQuery('#current_store_id').length == 0 && jQuery('.dont-show-store-popup').length == 0 ) {
        jQuery('.store-selector-modal').modal({
            backdrop: 'static',
            keyboard: false
        });
    }

}

function startingStoreSelectorGeocomplete() {

    jQuery("input#selectPlace").geocomplete();  // Option 1: Call on element.

}

function isGeolocationActive() {

    if (location.protocol == 'https:') {
        // Checking if the geolocation is enabled or not by the user
        if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(onSuccessGeolocating,
                onErrorGeolocating,
                {
                    enableHighAccuracy: true,
                    maximumAge: 5000,
                    timeout: 10000
                });
        }
        else {
            jQuery(".store-selector-modal #currentPlace").html("Active la geolocalización para buscar su tienda más cercana");
        }
    }

}

function showingStoresOnModal() {

    jQuery("#selectPlace").geocomplete({
        details: "#formChangeTienda",
        detailsScope: "#tiendaModal"
    })
        .bind("geocode:result", function (event, result) {
            console.log("Seleccionado lugar: " + result.formatted_address);
            var location = result.geometry.location;

            var data = {
                action: 'loadClosestsStores',
                security : WC_ALDI_StoreLocator.security,
                latitude: location.lat(),
                longitude: location.lng()
            };
            // We look for the closest stores according to the position
            jQuery.ajax({
                type: 'POST',
                data: data,
                url: WC_ALDI_StoreLocator.ajaxurl,
                dataType: 'json',
                success: function (data) {
                    console.log("Buscando tienda mas cercana");
                    var totalTiendas = data.length;

                    if (totalTiendas > 0) {

                        var htmlLista = "<div class='list-group'>";

                        console.log(data[0].DistanciaTienda);

                        if ( data[0].DistanciaTienda <= 100 ) {
                            // Less than 100km away
                            htmlLista = "<p>Estas son las tiendas Aldi más cercanas a la dirección que has indicado.</p><div class='list-group'>";
                        } else {
                            // More than 100km away
                            htmlLista = "<p>Estas son las tiendas que se encuentran a menor distancia de la dirección que has indicado. ¡Esperamos estar cada vez más cerca de ti! </p><div class='list-group'>";
                        }

                        jQuery.each(data, function (i, l) {
                            var ubicacion = 0;
                            if ( l.isBaleares == 1 ) {
                                ubicacion = 1;
                            }
                            htmlLista = htmlLista + "<a href='#' class='selector-tienda list-group-item' data-idtienda='" + l.IdTienda + "' data-latitude='" + l.latitude + "' data-longitude='" + l.longitude + "' data-postalcode='" + l.CodigoPostalTienda + "' data-codtienda='" + l.CodigoTienda + "' data-nombretienda='" + l.NombreTienda + "' data-isbaleares='" + ubicacion + "'><strong>" + l.NombreTienda + "</strong> <span class='ff-arial'>(" + parseFloat(l.DistanciaTienda.toFixed(2)) + " km)</span></a>";
                        });

                        htmlLista = htmlLista + "</div>";

                        // If the store is further than 100km, we show an option of not selecting one store
                        if ( data[0].DistanciaTienda > 100 ) {
                            htmlLista = htmlLista + "<p>Si no quieres seleccionar ninguna de estas tiendas, <a href='#' class='selector-tienda' data-codtienda='generic' data-nombretienda='Aldi Generico' data-isBaleares='0'>haz clic aquí</a>.</p>";
                        }

                        jQuery("#currentPlace").html(htmlLista);

                    } else {
                        jQuery("#currentPlace").html("No se ha encontrado ninguna tienda en la zona indicada.");
                    }

                }
            });
        })
        .bind("geocode:error", function (event, status) {
            console.log("ERROR: " + status);
        })
        .bind("geocode:multiple", function (event, results) {
            console.log("Multiple: " + results.length + " results found");
        });

    jQuery("#find").click(function () {
        jQuery("#selectPlace").trigger("geocode");
    });

    jQuery("#currentPlace").on("click", ".selector-tienda", function () {
        // We get the code of the selected store and we submit
        var idTienda     = jQuery(this).attr("data-idtienda");
        var codTienda    = jQuery(this).attr("data-codtienda");
        var nombreTienda = jQuery(this).attr("data-nombretienda");
        var isbaleares   = jQuery(this).attr("data-isbaleares");
        var latitude     = jQuery(this).attr("data-latitude");
        var longitude    = jQuery(this).attr("data-longitude");
        var postal_code  = jQuery(this).attr("data-postalcode");

        jQuery("#currentPlace").html("... cargando tienda");

        jQuery("#idTienda").val(idTienda);
        jQuery("#codTienda").val(codTienda);
        jQuery("#nombreTienda").val(nombreTienda);
        jQuery("#isBaleares").val(isbaleares);
        jQuery("#postal_code").val(postal_code);
        jQuery("#latitude").val(latitude);
        jQuery("#longitude").val(longitude);
        jQuery("#formChangeTienda").submit();
    });

    

}

function onSuccessGeolocating(position) {
    // We look for the closest store according to the position

    var data = {
        action: 'loadClosestsStores',
        security : WC_ALDI_StoreLocator.security,
        latitude: position.coords.latitude,
        longitude: position.coords.longitude
    };

    jQuery.ajax({
        type: 'POST',
        data: data,
        url: WC_ALDI_StoreLocator.ajaxurl,
        dataType: 'json',
        success: function (data) {
            console.log("Buscando tienda mas cercana");
            var totalTiendas = data.length;

            if (totalTiendas > 0) {
                var tiendaMasCercana = data[0];
                if (tiendaMasCercana != null) {
                    jQuery("#currentPlace").html("Parece que tu tienda mas cercana es <strong><a href='#' class='selector-tienda' data-codtienda='" + tiendaMasCercana.CodigoTienda + "' data-nombretienda='" + tiendaMasCercana.NombreTienda + "'>" + tiendaMasCercana.NombreTienda + "</a></strong>.");
                    jQuery("#codTienda").val(tiendaMasCercana.CodigoTienda);
                    jQuery("#nombreTienda").val(tiendaMasCercana.NombreTienda);

                } else {
                    jQuery("#currentPlace").html("No se ha encontrado ninguna tienda en su zona.");
                }
            }
            else {
                jQuery("#currentPlace").html("No se ha encontrado ninguna tienda en su zona.");
            }
        }
    });

}

function onErrorGeolocating(error) {
    switch (error.code) {
        case error.PERMISSION_DENIED:
            jQuery("#currentPlace").html("Active la geolocalización para buscar su tienda más cercana");
            break;

        case error.POSITION_UNAVAILABLE:
            jQuery("#currentPlace").html("Active la geolocalización para buscar su tienda más cercana");
            break;

        case error.TIMEOUT:
            jQuery("#currentPlace").html("Active la geolocalización para buscar su tienda más cercana");
            break;

        default:
            jQuery("#currentPlace").html("Active la geolocalización para buscar su tienda más cercana");
            break;
    }

}