'use strict';

var gulp = require('gulp');

// SASS

var sass = require('gulp-sass');
var sassGlob = require('gulp-sass-glob');
var sourcemaps = require('gulp-sourcemaps');
var autoprefixer = require('gulp-autoprefixer');

// CSS

var minify = require('gulp-minify-css');
var concat = require('gulp-concat');

// Concat js components files

gulp.task('js', function () {
    return gulp.src(['./modules/frontend/**/*.js'])
        .pipe(concat('frontend.js'))
        .pipe(gulp.dest('./assets/js'))
});

// Compile to *.css

gulp.task('css', function () {

    gulp.src('./modules/backend/**/*.scss')
        .pipe(sourcemaps.init())
        .pipe(sassGlob())
        .pipe(sass().on('error', sass.logError))
        .pipe(autoprefixer())
        .pipe(minify())
        .pipe(concat('backend.css'))
        .pipe(gulp.dest('./assets/css'))
    ;

    gulp.src('./modules/frontend/**/*.scss')
        .pipe(sourcemaps.init())
        .pipe(sassGlob())
        .pipe(sass().on('error', sass.logError))
        .pipe(autoprefixer())
        .pipe(minify())
        .pipe(concat('frontend.css'))
        .pipe(gulp.dest('./assets/css'))
    ;

});

gulp.task('js:watch', ['js'], function () {
    gulp.watch('./assets/js/*.js', ['js']);
    gulp.watch('./modules/frontend/**/*.js', ['js'])
});

gulp.task('css:watch', ['css'], function () {
    return gulp.watch(['./modules/frontend/**/*.scss'], ['css'])
});

gulp.task('build', ['css', 'js']);

gulp.task('watch', ['css:watch', 'js:watch']);